----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:36:15 02/14/2016 
-- Design Name: 
-- Module Name:    ram256x8 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.std_logic_signed.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity ram256x8 is
    Port ( wclk : in  STD_LOGIC;
           rclk : in  STD_LOGIC;
           we : in  STD_LOGIC;
           re : in  STD_LOGIC;
           di : in  STD_LOGIC_VECTOR (7 downto 0);
           wa : in  STD_LOGIC_VECTOR (7 downto 0);
           ra : in  STD_LOGIC_VECTOR (7 downto 0);
           do : out  STD_LOGIC_VECTOR (7 downto 0));
end ram256x8;

architecture Behavioral of ram256x8 is
type array16x8 is array(15 downto 0) of std_logic_vector(7 downto 0);
signal dpo : array16x8;
signal we_buf : std_logic_vector(15 downto 0);
begin
process(rclk)
begin
  if(rclk'event and rclk = '1')then
		if(re = '1')then
			do <= dpo(CONV_INTEGER(ra(7 downto 4)));
		end if;
  end if;
end process;
g_bit: for i in 0 to 7 generate
 g_depth: for j in 0 to 15 generate
  i_buf : RAM16X1D
   port map (
      DPO => dpo(j)(i),     -- Read-only 1-bit data output for DPRA
      SPO => open,     -- R/W 1-bit data output
      A0 => wa(0),       -- R/W address[0] input bit
      A1 => wa(1),       -- R/W address[1] input bit
      A2 => wa(2),       -- R/W address[2] input bit
      A3 => wa(3),       -- R/W ddress[3] input bit
      D => di(i),         -- Write 1-bit data input
      DPRA0 => ra(0), -- Read-only address[0] input bit
      DPRA1 => ra(1), -- Read-only address[1] input bit
      DPRA2 => ra(2), -- Read-only address[2] input bit
      DPRA3 => ra(3), -- Read-only address[3] input bit
      WCLK => wclk,   -- Write clock input
      WE => we_buf(j)        -- Write enable input
   );
 end generate;
end generate;
process(we,wa)
begin
	for i in 0 to 15 loop
		if(CONV_INTEGER(wa(7 downto 4)) = i)then
			we_buf(i) <= we;
		else
			we_buf(i) <= '0';
		end if;
	end loop;
end process;
end Behavioral;

